datacache <- new.env(hash=TRUE, parent=emptyenv())

hgu95bhsrefseq <- function() showQCData("hgu95bhsrefseq", datacache)
hgu95bhsrefseq_dbconn <- function() dbconn(datacache)
hgu95bhsrefseq_dbfile <- function() dbfile(datacache)
hgu95bhsrefseq_dbschema <- function(file="", show.indices=FALSE) dbschema(datacache, file=file, show.indices=show.indices)
hgu95bhsrefseq_dbInfo <- function() dbInfo(datacache)

hgu95bhsrefseqORGANISM <- "Homo sapiens"

.onLoad <- function(libname, pkgname)
{
    ## Connect to the SQLite DB
    dbfile <- system.file("extdata", "hgu95bhsrefseq.sqlite", package=pkgname, lib.loc=libname)
    assign("dbfile", dbfile, envir=datacache)
    dbconn <- dbFileConnect(dbfile)
    assign("dbconn", dbconn, envir=datacache)

    ## Create the OrgDb object
    sPkgname <- sub(".db$","",pkgname)
    txdb <- loadDb(system.file("extdata", paste(sPkgname,
      ".sqlite",sep=""), package=pkgname, lib.loc=libname),
                   packageName=pkgname)    
    dbNewname <- AnnotationDbi:::dbObjectName(pkgname,"ChipDb")
    ns <- asNamespace(pkgname)
    assign(dbNewname, txdb, envir=ns)
    namespaceExport(ns, dbNewname)
        
    ## Create the AnnObj instances
    ann_objs <- createAnnObjs.SchemaChoice("HUMANCHIP_DB", "hgu95bhsrefseq", "chip hgu95bhsrefseq", dbconn, datacache)
    mergeToNamespaceAndExport(ann_objs, pkgname)
    packageStartupMessage(AnnotationDbi:::annoStartupMessages("hgu95bhsrefseq.db"))
}

.onUnload <- function(libpath)
{
    dbFileDisconnect(hgu95bhsrefseq_dbconn())
}

